//---------------------------------------------------------------------------
// MixDir() is in global.cpp
#include <vcl\vcl.h>
#pragma hdrstop

#include "PgpDlgs.h"
#include "Pgpfiles.h"
#include "PGPbuffers.h"
#include "Global.h"
//#include "WipeDlgs.h"
#include "pgp.h"
#include "Mixmaster.h"
#include "view.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TPgpDlg *PgpDlg;
//---------------------------------------------------------------------------
void __fastcall Wipefile(AnsiString &filename, int passes)
{
   ActMainForm->Perform(WM_WIPEFILE,(WPARAM)passes,(LPARAM)filename.c_str());
}
//---------------------------------------------------------------------------
__fastcall TPgpDlg::TPgpDlg(TComponent* Owner)
  : TForm(Owner)
{
   TheRecips = new TStringList();
// TheText = new TStringList();
   ProgressBar = NULL;
   Feedback = NULL;
   Messages = NULL;
}
//---------------------------------------------------------------------------
__fastcall TPgpDlg::TPgpDlg(AnsiString PubRing, AnsiString SecRing, AnsiString RemRing,
   TForm* Owner) : TForm(Owner)
{
   dat = buf_new(); pas = buf_new(); enc = buf_new(); sig = buf_new();
   dat->sensitive = pas->sensitive = enc->sensitive = sig->sensitive = true;
   PKeyRing = PubRing; SKeyRing = SecRing; RKeyRing = RemRing;
   TheRecips = new TStringList();
   Topper = new TStringList();
 //TheText = new TStringList();
   MainForm = (TForm*)Owner;
   //ClearSign = false;
   ToRemailer = false;
   ProgressBar = NULL;
   Feedback = NULL;
   Messages = NULL;
}
//---------------------------------------------------------------------------
__fastcall TPgpDlg::~TPgpDlg()
{
   delete Topper;
   delete TheRecips;
   buf_free(pas);
   buf_free(dat);
   buf_free(enc);
}
//---------------------------------------------------------------------------
bool __fastcall TPgpDlg::IsRemailed(TStrings *Recips)
{
   bool remail = false;
   TPGPbuffer *cpkkeys = new TPGPbuffer(PgpRemailRing());
   AnsiString cpknames = cpkkeys->getuserids();
   for (int i=0; i<Recips->Count; i++)
   {
       if (cpknames.Pos(Recips->Strings[i])>0)
       {
          remail = true;
          break;
       }
   }
   delete cpkkeys;
   return remail;
}
//---------------------------------------------------------------------------
int __fastcall TPgpDlg::EncryptMessage(TStrings *Message, TStrings *Recips)
{
   int i;
   Caption = "Pgp Encrypt"; Sleep(100);
   Cap = "...encrypting...";
   Label1->Caption = Cap;
   AppProcessMessages();
   for (i=0; i<Message->Count; i++)
      buf_appends(dat,s(Message->Strings[i]+"\n").c_str());
   for (i=0; i<Recips->Count; i++)
      buf_appends(enc,s(Recips->Strings[i]+"\n").c_str());

   switch (Execute(mPGPencrypt))
   {
      case PGP_OK  : Message->Text = AnsiString((char*)dat->data); break;
      case PGP_ERR : PGPerror("Specified public key not found!"); break;
      case PGP_PASS: PGPerror("Bad signature passphrase!"); break;
      default: PGPerror("PGP encrypt error: "+AnsiString(Result));
   }
   if (Result==PGP_OK)
   {
      if (IsRemailed(Recips)) Message->Insert(0,"::\r\nEncrypted: PGP\r\n");
      return Result;
   }
   ModalResult = mrCancel;
   return Result;
}
//---------------------------------------------------------------------------
int __fastcall TPgpDlg::SignMessage(TStrings *Message, AnsiString &SigId,
   AnsiString &passphrase)
{
   int pos;
   AnsiString line,text;
   Caption = "Pgp Sign";  Sleep(100);
   Cap = "...signing..."; Label1->Caption = Cap;
   buf_sets(pas,passphrase.c_str()); 
   buf_sets(sig,SigId.c_str());
   Application->ProcessMessages();

   if (ToRemailer)
   {
      text = Message->Text;
      if ((pos=text.Pos("\r\n\r\n"))==text.Pos("\r\n\r\n::\r\n")) text.Delete(pos,2);
      if ((pos=text.Pos("\r\n\r\n"))==text.Pos("\r\n\r\n##\r\n")) text.Delete(pos,2);
      Message->Text = text;
   }

   for (int i=0; i<Message->Count; i++)
      buf_appends(dat,AnsiString(Message->Strings[i]+"\n").c_str());

   switch (Execute(mPGPsign))
   {
      case PGP_OK : Message->SetText((char*)dat->data); break;
      case PGP_ERR: PGPerror("Specified signing key not found!"); break;
      default: PGPerror("PGP signing error: "+AnsiString(Result));
   }

   if (ToRemailer)
   {
      text = Message->Text;
      if ((pos=text.Pos("\r\n::\r\n"))>0) text.Insert("\r\n",pos);
      if ((pos=text.Pos("\r\n##\r\n"))>0) text.Insert("\r\n",pos);
      Message->Text = text;
   }

   if (Result!=PGP_OK) ModalResult = mrCancel;
   return Result;
}
//---------------------------------------------------------------------------
int __fastcall TPgpDlg::EncryptCMessage(TStrings *Message, AnsiString &Passphrase)
{
   Caption = "Pgp Encrypt"; Sleep(100);
   Cap = "...encrypting...";
   Label1->Caption = Cap;
   Application->ProcessMessages();
   for (int i=0; i<Message->Count; i++)
      buf_appends(dat,s(Message->Strings[i]+"\n").c_str());
   buf_appends(enc,Passphrase.c_str()); ClearString(Passphrase);
   switch (Execute(mPGPencryptc))
   {
      case PGP_OK  : Message->Text = (char*)dat->data; break;
      case PGP_ERR : PGPerror("Specified key not found!"); break;
      case PGP_PASS: PGPerror("Bad signature passphrase!"); break;
      default: PGPerror("PGP encrypt error: "+AnsiString(Result));
   }
   if (Result!=PGP_OK) ModalResult = mrCancel;
   return Result;
}
//---------------------------------------------------------------------------
int __fastcall TPgpDlg::EncryptSignMessage(TStrings *Message, AnsiString &SigId,
   AnsiString &passphrase, TStrings *Recips)
{
   int i;
   AnsiString line;
   Caption = "Pgp Sign Encrypt"; Sleep(100);
   Cap = "...signing/encrypting..."; Label1->Caption = Cap;
   Application->ProcessMessages();

   for (i=0; i<Message->Count; i++)
      buf_appends(dat,AnsiString(Message->Strings[i]+"\n").c_str());
   for (i=0; i<Recips->Count; i++)
      buf_appends(enc,s(Recips->Strings[i]+"\n").c_str());

   buf_sets(pas,passphrase.c_str());
   buf_sets(sig,SigId.c_str());

   switch (Execute(mPGPencryptsign))
   {
      case PGP_OK  : Message->Text = AnsiString((char*)dat->data); break;
      case PGP_ERR : PGPerror("Specified public key not found!"); break;
      case PGP_PASS: PGPerror("Bad signature passphrase!"); break;
      default: PGPerror("PGP encrypt error: "+AnsiString(Result));
   }
   if (Result==PGP_OK && ToRemailer) Message->Insert(0,"::\r\nEncrypted: PGP\r\n");
   if (Result!=PGP_OK) ModalResult = mrCancel;
   return Result;
}
//---------------------------------------------------------------------------
char* __fastcall PoundString(int length)
{
   AnsiString poundline;
   return s(poundline.StringOfChar('#',length)+"\n").c_str();
}
//---------------------------------------------------------------------------
int __fastcall TPgpDlg::DecryptMessage(BUFFER *Message, AnsiString &passphrase)
{
   AnsiString line;
   Caption = "Pgp Decrypt"; Sleep(100);
   Cap = "...decrypting message..."; Label1->Caption = Cap;
   Application->ProcessMessages();
   buf_set(dat,Message);
   buf_sets(pas,passphrase.c_str());
   buf_clear(sig);
   int minwide=58;
   switch (Execute(mPGPdecrypt))
   {
      case PGP_OK: buf_set(Message,dat); break;
      case PGP_ERR: PGPerror("The message can't be read."); break;
      case PGP_PASS: PGPerror("Bad passphrase."); break;
      case PGP_NOMSG: PGPerror("Message is not an OpenPGP message."); break;
      case PGP_NODATA: PGPerror("OpenPGP message does not contain user data."); break;
      case PGP_SIGOK:
         buf_sets(Message,PoundString(sig->length<minwide-6 ? minwide:sig->length+6));
         buf_appends(Message,"# "); buf_cat(Message,sig); buf_appendc(Message,'\n');
         buf_appends(Message,"# Digital Signature OK\n\n");
         buf_cat(Message,dat);
         break;
      case PGP_SIGBAD:
         buf_sets(Message,PoundString(sig->length<minwide-10 ? minwide:sig->length+10));
         buf_appends(Message,"# Key "); buf_cat(Message,sig); buf_appendc(Message,'\n');
         buf_appends(Message,"# Verify FAILED, bad digital signature\n\n");
         buf_cat(Message,dat);
         break;
      case PGP_SIGNKEY:
         buf_sets(Message,PoundString(minwide));
         buf_appends(Message,"# Unknown key "); buf_cat(Message,sig); buf_appends(Message,", Can't verify digital signature\n\n");
         buf_cat(Message,dat);
         break;
   }
   if (Result!=PGP_OK && Result!=PGP_SIGOK && Result!=PGP_SIGBAD && Result!=PGP_SIGNKEY)
      ModalResult = mrCancel;
   return Result;
}
//---------------------------------------------------------------------------
int __fastcall TPgpDlg::VerifyMessage(BUFFER *Message, BUFFER *Sig)
{
   AnsiString line,id;
   Caption = "Pgp Verify"; Sleep(100);
   Cap = "...checking signature..."; Label1->Caption = Cap;
   TStringList *tmp = new TStringList();
   Application->ProcessMessages();
   buf_set(dat,Message);
   buf_set(sig,Sig);
   int minwide=58;
   switch (Execute(mPGPverify))
   {
      case PGP_OK: buf_set(Message,dat); break;
      case PGP_ERR: PGPerror("The message can't be read."); break;
      case PGP_PASS: PGPerror("Bad passphrase."); break;
      case PGP_NOMSG: PGPerror("Message is not an OpenPGP message."); break;
      case PGP_NODATA: PGPerror("OpenPGP message does not contain user data."); break;
      case PGP_SIGOK:
         buf_sets(Message,PoundString(sig->length<minwide-6 ? minwide:sig->length+6));    //"##################################");
         buf_appends(Message,"# "); buf_cat(Message,dat); buf_appendc(Message,'\n');
         buf_appends(Message,"# Digital Signature OK\n\n");
         buf_cat(Message,sig);
         break;
      case PGP_SIGBAD:
         buf_sets(Message,PoundString(sig->length<minwide-10 ? minwide:sig->length+10));    //"##################################");
         buf_appends(Message,"# Key "); buf_cat(Message,sig); buf_appendc(Message,'\n');
         buf_appends(Message,"# Verify FAILED, bad digital signature\n#\n\n");
         buf_cat(Message,dat);
         break;
      case PGP_SIGNKEY:
         tmp->SetText((char*)sig->data);
         sm(tmp->Text);
         if (tmp->Count)
         {
            id = tmp->Strings[tmp->Count-1];
            if (!id.IsEmpty()) id = " 0x"+id;
            tmp->Delete(tmp->Count-1);
            buf_sets(sig,tmp->Text.c_str());
         }
         buf_sets(Message,PoundString(minwide));
         buf_appends(Message,"# Unknown key"); buf_appends(Message,id.c_str());
         buf_appends(Message,", Can't verify digital signature\n");
         buf_appends(Message,"#\n");
         buf_cat(Message,sig);
         break;
   }
   if (Result!=PGP_OK && Result!=PGP_SIGOK && Result!=PGP_SIGBAD && Result!=PGP_SIGNKEY)
      ModalResult = mrCancel;
   delete tmp;
   return Result;
}
//---------------------------------------------------------------------------
void __fastcall TPgpDlg::Timer1Timer(TObject *Sender)
{
   TPGPbuffer *pub,*cpk,*per;
   AnsiString tmpPubring = GetTempFilename();
   ///DeleteFile(tmpPubRing);
   Timer1->Enabled = false;
   Timer2->Enabled = true;
   Label1->Caption = Cap;
   AppProcessMessages();
   TStringList *msg = new TStringList();
   switch (Mode)
   {
      case mPGPverify:
         Result = pgp_decrypt(dat,NULL,sig,PKeyRing.c_str(),NULL);
         break;
      case mPGPdecrypt:
         Result = pgp_decrypt(dat,pas,sig,PKeyRing.c_str(),SKeyRing.c_str());
         break;
      case mPGPsign:
         Result = pgp_mailenc(PGP_SIGN,dat,(char*)sig->data,pas,NULL,SKeyRing.c_str());
         break;
      case mPGPencrypt:
         pub = new TPGPbuffer();
         per = new TPGPbuffer(PgpPublicRing());
         cpk = new TPGPbuffer(PgpRemailRing());
         pub->copyfrom(per); pub->copyfrom(cpk);
         pub->SaveToFile(tmpPubring);

         Result = pgp_encrypt(PGP_ENCRYPT|PGP_TEXT,dat,enc,NULL,NULL,
            tmpPubring.c_str(), NULL);

         Wipefile(tmpPubring,1);
         delete cpk;
         delete per;
         delete pub;
         break;
      case mPGPencryptc:
         Result = pgp_encrypt(PGP_CONVENTIONAL|PGP_TEXT,dat,enc,NULL,NULL,NULL,NULL);
         break;
      case mPGPencryptsign:
         pub = new TPGPbuffer();
         per = new TPGPbuffer(PgpPublicRing());
         cpk = new TPGPbuffer(PgpRemailRing());
         pub->copyfrom(per); pub->copyfrom(cpk);
         pub->SaveToFile(tmpPubring);

         Result = pgp_encrypt(PGP_ENCRYPT|PGP_SIGN|PGP_TEXT|PGP_REMAIL,dat,enc,sig,pas,
            tmpPubring.c_str(),SKeyRing.c_str());

         Wipefile(tmpPubring,1);
         delete cpk;
         delete per;
         delete pub;
         break;
   }
   delete msg;
   Timer2->Enabled = false; Sleep(100); if (Mode!=mPGPverify) Sleep(100);
   Hide(); AppProcessMessages(); Sleep(100); if (Mode!=mPGPverify) Sleep(100);
   if (ModalResult==mrNone) ModalResult=mrOk;
 }
//---------------------------------------------------------------------------
void __fastcall TPgpDlg::Timer2Timer(TObject *Sender)
{
   if (Label1->Caption.IsEmpty()) Label1->Caption = Cap;
   else Label1->Caption = "";
}
//---------------------------------------------------------------------------
void __fastcall TPgpDlg::FormShow(TObject *Sender)
{
   CenterDialog(this,ActMainForm);
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
int __fastcall TPgpDlg::Execute(int mode)
{
//sm((int)dat->length);
   Mode = mode; ShowModal();
//sm((int)Result);
//sm((int)dat->length);
   return Result;
}
//---------------------------------------------------------------------------
void __fastcall TPgpDlg::PGPerror(AnsiString &errorStr, AnsiString title)
{
   MsgBoxHwnd(Handle,errorStr,title,MB_OK);
}
//---------------------------------------------------------------------------








