#define _WINSOCKAPI_
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "PopProfDlg.h"
#include "HelpDlgs.h"
#include "global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TAccProfDlg *AccProfDlg;
//---------------------------------------------------------------------------
AnsiString __fastcall NewAcctProfile(TForm *Owner)
{
   AnsiString profdata;
   AccProfDlg = new TAccProfDlg(Owner);
   CenterDialog(AccProfDlg,Owner);
   AccProfDlg->Top += 6;
   AccProfDlg->ActiveControl = AccProfDlg->AccountUID;
   AccProfDlg->SetProfile("");
   AccProfDlg->ShowModal();
   if (AccProfDlg->ModalResult==mrOk)
      profdata = AccProfDlg->GetProfile();
   delete AccProfDlg;
   return profdata;
}
//---------------------------------------------------------------------------
AnsiString __fastcall EditAcctProfile(TForm *Owner, AnsiString &ProfileStr)
{
   AnsiString profdata;
   AccProfDlg = new TAccProfDlg(Owner);
   CenterDialog(AccProfDlg,Owner);
   AccProfDlg->Top += 6;
   AccProfDlg->ActiveControl = AccProfDlg->AccountUID;
   AccProfDlg->SetProfile(ProfileStr);
   AccProfDlg->ShowModal();
   if (AccProfDlg->ModalResult==mrOk)
      profdata = AccProfDlg->GetProfile();
   delete AccProfDlg;
   return profdata;
}
//---------------------------------------------------------------------------
__fastcall TAccProfDlg::TAccProfDlg(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
AnsiString __fastcall TAccProfDlg::GetProfile()
{
   AnsiString Y="1",N="0",divider=POPDATDIV;
   AnsiString profile =
      s("checked="+(Checked->Checked?Y:N)+divider)+
      s("account="+AccountUID->Text+POPACCDIV+Pop3Host->Text+divider)+
      s("password="+Password->Text+divider)+
      s("remember="+(Remember->Checked?Y:N)+divider)+
      s("delete="+(Delete->Checked?Y:N)+divider)+
      s("pgponly="+(PgpOnly->Checked?Y:N)+divider)+
      s("end=1");
   return profile;
}
//---------------------------------------------------------------------------
void __fastcall TAccProfDlg::SetProfile(AnsiString &ProfileStr)
{
   //ProfileStr = ProfileStr.LowerCase();
   AnsiString item,Y="1";
   TStringList *acct = new TStringList();
   int i=0; while ((item=GetParam(i++,ProfileStr,POPDATDIV))!="")
      acct->Add(item);
   item = acct->Values["account"];
   if (item.Pos(POPACCDIV)>0)
   {
      AccountUID->Text = GetParam(0,item,POPACCDIV);
      Pop3Host->Text = GetParam(1,item,POPACCDIV);
   }
   else
   {
      AccountUID->Text = GetParam(0,item,"@");
      Pop3Host->Text = GetParam(1,item,"@");
   }
   Checked->Checked = acct->Values["checked"]==Y;
   Password->Text = acct->Values["password"];
   Remember->Checked = acct->Values["remember"]==Y;
   PgpOnly->Checked = acct->Values["pgponly"]==Y;
   Delete->Checked = acct->Values["delete"]==Y;
   profile = GetProfile();
   delete acct;
}
//---------------------------------------------------------------------------
void __fastcall TAccProfDlg::HideTypeClick(TObject *Sender)
{
   Password->PasswordChar = HideType->Checked ? '*' : '\0';
}
//---------------------------------------------------------------------------
void __fastcall TAccProfDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   switch (ModalResult)
   {
      case mrOk:
         if (AccountUID->Text.IsEmpty())
         {
            MsgBoxHwnd(Handle,"Login ID field required!",
              "Profile Error",MB_OK
            );
            ActiveControl = AccountUID;
            CanClose = false;
            break;
         }
         if (Pop3Host->Text.IsEmpty())
         {
            MsgBoxHwnd(Handle,"POP3 Host field required!",
              "Profile Error",MB_OK
            );
            ActiveControl = Pop3Host;
            CanClose = false;
            break;
         }
         if (Remember->Checked && Password->Text.IsEmpty())
         {
            MsgBoxHwnd(Handle,"You have REMEMBER (password) checked, but no PASSWORD!",
              "Profile Error",
               MB_OK
            );
            ActiveControl = Password;
            CanClose = false;
            break;
         }
         break;

      case mrCancel:
         if (profile!=GetProfile())
         {
            switch(MsgBoxHwnd(Handle,
               "The account data has been modified.\nSave your changes?",
               "Confirm",MB_YESNOCANCEL))
            {
               case ID_YES    : ModalResult = mrOk; break;
               case ID_CANCEL : CanClose = false; break;
               case ID_NO     : break;
            }
         }
   }
}
//---------------------------------------------------------------------------
void __fastcall TAccProfDlg::HelpBtnClick(TObject *Sender)
{
   OpenHelp("POP3","POP3 Accounts And Features","POP3 Account Profile Dialog",
      this
   );
}
//---------------------------------------------------------------------------
