//---------------------------------------------------------------------------
#ifndef nymmailH
#define nymmailH

#include "fileman.h"
//---------------------------------------------------------------------------
bool __fastcall HasNyms();
bool __fastcall HasActualNyms();
bool __fastcall NymInit(HINSTANCE HMixLib, HINSTANCE HSSLLib, HWND AppHandle);
void __fastcall NymShutDown();
char*__fastcall GetNymLibVersion();
char*__fastcall GetNymLibName();

char*__fastcall DecryptNymMessage(TForm *Owner, char *message, int &errcode);
bool __fastcall RunNymWizard(TForm *Owner);
void __fastcall RunFinger(TForm *Owner);

typedef void __fastcall (*NYMINIT)(HINSTANCE, HINSTANCE, HWND);
typedef void __fastcall (*NYMSHUTDOWN)();
typedef char*__fastcall (*GET_NYMLIBVERSION)();
typedef char*__fastcall (*GET_NYMLIBNAME)();
typedef char*__fastcall (*DECRYPTNYMMESSAGE)(TForm*,char*,int&);
typedef bool __fastcall (*RUNNYMWIZARD)(TForm*);
typedef void __fastcall (*RUNFINGER)(TForm*);

const AnsiString NymConfigHdr = "Nym-Config: ";
const AnsiString NymProfilesKey = "nyms"+PS+"profiles";    // current nym profiles
const AnsiString NymProfOldsKey = "nyms"+PS+"profolds";    // last previous profile
const AnsiString NymRetiredsKey = "nyms"+PS+"retireds";    // retired nyms
const AnsiString NymConfigsKey  = "nyms"+PS+"configs";  // last unencrypted config message
const AnsiString NymReplaysKey  = "nyms"+PS+"replays";     // last encrypted config message
const AnsiString NymRBTempsKey = "nyms"+PS+"blktemplates"; // reply block templates
const AnsiString LastNymProfileKey = "lastnymprofile";
const AnsiString NymAutoDecrypt = "nymautodecrypt";
const AnsiString NymShowIntro = "nymshowintro";
const AnsiString DefNymCmds =
   "+acksend,-signsend,+cryptrecv,-fixedsize,-disable,-nobcc,-fingerkey";
const AnsiString NymCommandsKey = "nyms"+PS+"commands"; // editable list of commands
const AnsiString CpkDirectives =
   "Reply-Block:,Anon-To:,Anon-Post-To:,Remail-To:,Latent-Time:,Encrypt-Key:";
const AnsiString CpkDirectivesKey = "Cpunk"+PS+"Directives";

// this is a mode used in the GetMergeMessage function clipreply.h
const int modeNymcnfg = 2;

#define NYMSHOWINTROSET(val)  PutAppIni(NymShowIntro,val)
#define NYMSHOWINTRO         (GetAppIni(NymShowIntro,"1")=="1")
#define NYMAUTODECRYPT       (GetAppIni(NymAutoDecrypt,"1")=="1")
//---------------------------------------------------------------------------
extern HINSTANCE hNymLib;
#endif
